﻿//using HeuristicLab.Algorithms.GeneticAlgorithm;
//using HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm;
//using HeuristicLab.Common;
//using HeuristicLab.Core;
//using HeuristicLab.Core.Networks;
//using HeuristicLab.Data;
//using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

//namespace HeuristicLab.Networks.IntegratedOptimization {
//  [Item("TtpNetwork", "An optimization network for the TTP.")]
//  [Creatable("Optimization Networks")]
//  [StorableClass]
//  // partial ttp
//  // User-defined variegation (exchange all cities with all deselected cities)
//  // 1) best ksp
//  // 2) best reduced tsp
//  // 3) local optimization of tour
//  // 4) if better quality, then increase ksp values for items found in better city
//  public sealed class TtpNetwork : Network {
//    [StorableConstructor]
//    private TtpNetwork(bool deserializing) : base(deserializing) { }
//    private TtpNetwork(TtpNetwork original, Cloner cloner) : base(original, cloner) { }
//    public TtpNetwork() : base("TtpNetwork") {
//      var orchestratorNode = new TtpOrchestratorNode1();
//      Nodes.Add(orchestratorNode);

//      var tspSolverNode = new OrchestratedAlgorithmNode("TspSolver");
//      tspSolverNode.Algorithm = new OffspringSelectionGeneticAlgorithm();
//      tspSolverNode.Algorithm.Problem = orchestratorNode.TspParameter.Value;
//      orchestratorNode.TspSolverOrchestrationPort.ConnectedPort = tspSolverNode.OrchestrationPort;
//      Nodes.Add(tspSolverNode);

//      var kspSolverNode = new OrchestratedAlgorithmNode("KspSolver");
//      kspSolverNode.Algorithm = new GeneticAlgorithm();
//      kspSolverNode.Algorithm.Problem = orchestratorNode.KspParameter.Value;
//      orchestratorNode.KspSolverOrchestrationPort.ConnectedPort = kspSolverNode.OrchestrationPort;
//      Nodes.Add(kspSolverNode);

//      #region Import
//      DoubleMatrix tspCoordinates;
//      IntValue kspCapacity; IntArray kspItemWeights; IntArray kspItemValues;
//      IntArray ttpAvailability; DoubleValue ttpMinSpeed; DoubleValue ttpMaxSpeed; DoubleValue ttpRentingRatio;
//      TtpImporter.ImportTtpInstance(@"ttp-instances\berlin52-ttp\berlin52_n51_uncorr_01.ttp",
//        out tspCoordinates,
//        out kspCapacity, out kspItemValues, out kspItemWeights,
//        out ttpAvailability, out ttpMinSpeed, out ttpMaxSpeed, out ttpRentingRatio);

//      var tsp = orchestratorNode.TspParameter.Value;
//      tsp.Coordinates = tspCoordinates;
//      var ksp = orchestratorNode.KspParameter.Value;
//      ksp.KnapsackCapacity = kspCapacity;
//      ksp.Penalty.Value = ksp.KnapsackCapacity.Value;
//      ksp.Values = kspItemValues;
//      ksp.Weights = kspItemWeights;

//      orchestratorNode.AvailabilityParameter.Value = ttpAvailability;
//      orchestratorNode.MinSpeedParameter.Value = ttpMinSpeed;
//      orchestratorNode.MaxSpeedParameter.Value = ttpMaxSpeed;
//      orchestratorNode.RentingRatioParameter.Value = ttpRentingRatio;
//      #endregion
//    }

//    public override IDeepCloneable Clone(Cloner cloner) {
//      return new TtpNetwork(this, cloner);
//    }
//  }
//}
